import{s as Ne,n as ke,o as Te}from"../chunks/scheduler.7da89386.js";import{S as Be,i as Oe,g as i,s as a,r as c,A as Ie,h as r,f as t,c as l,j as g,u as p,x as J,k as f,y as s,a as n,v as h,d as _,t as u,w as v}from"../chunks/index.0b7befd3.js";import{D as $}from"../chunks/Docstring.80026b50.js";import{H as Fe,E as De}from"../chunks/EditOnGithub.0cb2bc8e.js";function Ee(_e){let b,K,R,Q,C,X,d,z,me,P,ue="Base configuration class for models.",ce,U,ve=`Methods:
<strong>post_init</strong>(): Performs post-initialization checks on the configuration.
_init_configs(model_name, env_config): Initializes the model configuration.
init_configs(env_config): Initializes the model configuration using the environment configuration.
get_model_sha(): Retrieves the SHA of the model.`,Y,M,w,Z,N,k,ee,y,T,ge,x,B,pe,V,be=`Returns the list of optional keys in an endpoint model configuration. By default, the code requires that all the
keys be specified in the configuration in order to launch the endpoint. This function returns the list of keys
that are not required and can remain None.`,te,O,I,oe,F,D,ne,E,q,ae,m,A,fe,H,ye="Create a model configuration based on the provided arguments.",he,W,$e=`ValueError: If multichoice continuations both should start with a space and should not start with a space.
ValueError: If a base model is not specified when using delta weights or adapter weights.
ValueError: If a base model is specified when not using delta weights or adapter weights.`,le,L,ie,j,re;return C=new Fe({props:{title:"ModelConfig",local:"lighteval.models.model_config.BaseModelConfig",headingTag:"h1"}}),z=new $({props:{name:"class lighteval.models.model_config.BaseModelConfig",anchor:"lighteval.models.model_config.BaseModelConfig",parameters:[{name:"pretrained",val:": str"},{name:"accelerator",val:": Accelerator = None"},{name:"tokenizer",val:": typing.Optional[str] = None"},{name:"multichoice_continuations_start_space",val:": typing.Optional[bool] = None"},{name:"pairwise_tokenization",val:": bool = False"},{name:"subfolder",val:": typing.Optional[str] = None"},{name:"revision",val:": str = 'main'"},{name:"batch_size",val:": int = -1"},{name:"max_gen_toks",val:": typing.Optional[int] = 256"},{name:"max_length",val:": typing.Optional[int] = None"},{name:"add_special_tokens",val:": bool = True"},{name:"model_parallel",val:": typing.Optional[bool] = None"},{name:"dtype",val:": typing.Union[str, torch.dtype, NoneType] = None"},{name:"device",val:": typing.Union[int, str] = 'cuda'"},{name:"quantization_config",val:": typing.Optional[transformers.utils.quantization_config.BitsAndBytesConfig] = None"},{name:"trust_remote_code",val:": bool = False"},{name:"use_chat_template",val:": bool = False"},{name:"compile",val:": bool = False"}],parametersDescription:[{anchor:"lighteval.models.model_config.BaseModelConfig.pretrained",description:`<strong>pretrained</strong> (str) &#x2014;
HuggingFace Hub model ID name or the path to a pre-trained
model to load. This is effectively the <code>pretrained_model_name_or_path</code>
argument of <code>from_pretrained</code> in the HuggingFace <code>transformers</code> API.`,name:"pretrained"},{anchor:"lighteval.models.model_config.BaseModelConfig.accelerator",description:"<strong>accelerator</strong> (Accelerator) &#x2014; accelerator to use for model training.",name:"accelerator"},{anchor:"lighteval.models.model_config.BaseModelConfig.tokenizer",description:`<strong>tokenizer</strong> (Optional[str]) &#x2014; HuggingFace Hub tokenizer ID that will be
used for tokenization.`,name:"tokenizer"},{anchor:"lighteval.models.model_config.BaseModelConfig.multichoice_continuations_start_space",description:`<strong>multichoice_continuations_start_space</strong> (Optional[bool]) &#x2014; Whether to add a
space at the start of each continuation in multichoice generation.
For example, context: &#x201C;What is the capital of France?&#x201D; and choices: &#x201C;Paris&#x201D;, &#x201C;London&#x201D;.
Will be tokenized as: &#x201C;What is the capital of France? Paris&#x201D; and &#x201C;What is the capital of France? London&#x201D;.
True adds a space, False strips a space, None does nothing`,name:"multichoice_continuations_start_space"},{anchor:"lighteval.models.model_config.BaseModelConfig.pairwise_tokenization",description:"<strong>pairwise_tokenization</strong> (bool) &#x2014; Whether to tokenize the context and continuation as separately or together.",name:"pairwise_tokenization"},{anchor:"lighteval.models.model_config.BaseModelConfig.subfolder",description:"<strong>subfolder</strong> (Optional[str]) &#x2014; The subfolder within the model repository.",name:"subfolder"},{anchor:"lighteval.models.model_config.BaseModelConfig.revision",description:"<strong>revision</strong> (str) &#x2014; The revision of the model.",name:"revision"},{anchor:"lighteval.models.model_config.BaseModelConfig.batch_size",description:"<strong>batch_size</strong> (int) &#x2014; The batch size for model training.",name:"batch_size"},{anchor:"lighteval.models.model_config.BaseModelConfig.max_gen_toks",description:"<strong>max_gen_toks</strong> (Optional[int]) &#x2014; The maximum number of tokens to generate.",name:"max_gen_toks"},{anchor:"lighteval.models.model_config.BaseModelConfig.max_length",description:"<strong>max_length</strong> (Optional[int]) &#x2014; The maximum length of the generated output.",name:"max_length"},{anchor:"lighteval.models.model_config.BaseModelConfig.add_special_tokens",description:`<strong>add_special_tokens</strong> (bool, optional, defaults to True) &#x2014; Whether to add special tokens to the input sequences.
If <code>None</code>, the default value will be set to <code>True</code> for seq2seq models (e.g. T5) and
<code>False</code> for causal models.`,name:"add_special_tokens"},{anchor:"lighteval.models.model_config.BaseModelConfig.model_parallel",description:`<strong>model_parallel</strong> (bool, optional, defaults to False) &#x2014;
True/False: force to use or not the <code>accelerate</code> library to load a large
model across multiple devices.
Default: None which corresponds to comparing the number of processes with
the number of GPUs. If it&#x2019;s smaller =&gt; model-parallelism, else not.`,name:"model_parallel"},{anchor:"lighteval.models.model_config.BaseModelConfig.dtype",description:`<strong>dtype</strong> (Union[str, torch.dtype], optional, defaults to None) &#x2014;):
Converts the model weights to <code>dtype</code>, if specified. Strings get
converted to <code>torch.dtype</code> objects (e.g. <code>float16</code> -&gt; <code>torch.float16</code>).
Use <code>dtype=&quot;auto&quot;</code> to derive the type from the model&#x2019;s weights.`,name:"dtype"},{anchor:"lighteval.models.model_config.BaseModelConfig.device",description:"<strong>device</strong> (Union[int, str]) &#x2014; device to use for model training.",name:"device"},{anchor:"lighteval.models.model_config.BaseModelConfig.quantization_config",description:`<strong>quantization_config</strong> (Optional[BitsAndBytesConfig]) &#x2014; quantization
configuration for the model, manually provided to load a normally floating point
model at a quantized precision. Needed for 4-bit and 8-bit precision.`,name:"quantization_config"},{anchor:"lighteval.models.model_config.BaseModelConfig.trust_remote_code",description:`<strong>trust_remote_code</strong> (bool) &#x2014; Whether to trust remote code during model
loading.`,name:"trust_remote_code"}],source:"https://github.com/huggingface/lighteval/blob/main/src/lighteval/models/model_config.py#L48"}}),w=new $({props:{name:"class lighteval.models.model_config.AdapterModelConfig",anchor:"lighteval.models.model_config.AdapterModelConfig",parameters:[{name:"pretrained",val:": str"},{name:"accelerator",val:": Accelerator = None"},{name:"tokenizer",val:": typing.Optional[str] = None"},{name:"multichoice_continuations_start_space",val:": typing.Optional[bool] = None"},{name:"pairwise_tokenization",val:": bool = False"},{name:"subfolder",val:": typing.Optional[str] = None"},{name:"revision",val:": str = 'main'"},{name:"batch_size",val:": int = -1"},{name:"max_gen_toks",val:": typing.Optional[int] = 256"},{name:"max_length",val:": typing.Optional[int] = None"},{name:"add_special_tokens",val:": bool = True"},{name:"model_parallel",val:": typing.Optional[bool] = None"},{name:"dtype",val:": typing.Union[str, torch.dtype, NoneType] = None"},{name:"device",val:": typing.Union[int, str] = 'cuda'"},{name:"quantization_config",val:": typing.Optional[transformers.utils.quantization_config.BitsAndBytesConfig] = None"},{name:"trust_remote_code",val:": bool = False"},{name:"use_chat_template",val:": bool = False"},{name:"compile",val:": bool = False"},{name:"base_model",val:": str = None"}],source:"https://github.com/huggingface/lighteval/blob/main/src/lighteval/models/model_config.py#L193"}}),k=new $({props:{name:"class lighteval.models.model_config.DeltaModelConfig",anchor:"lighteval.models.model_config.DeltaModelConfig",parameters:[{name:"pretrained",val:": str"},{name:"accelerator",val:": Accelerator = None"},{name:"tokenizer",val:": typing.Optional[str] = None"},{name:"multichoice_continuations_start_space",val:": typing.Optional[bool] = None"},{name:"pairwise_tokenization",val:": bool = False"},{name:"subfolder",val:": typing.Optional[str] = None"},{name:"revision",val:": str = 'main'"},{name:"batch_size",val:": int = -1"},{name:"max_gen_toks",val:": typing.Optional[int] = 256"},{name:"max_length",val:": typing.Optional[int] = None"},{name:"add_special_tokens",val:": bool = True"},{name:"model_parallel",val:": typing.Optional[bool] = None"},{name:"dtype",val:": typing.Union[str, torch.dtype, NoneType] = None"},{name:"device",val:": typing.Union[int, str] = 'cuda'"},{name:"quantization_config",val:": typing.Optional[transformers.utils.quantization_config.BitsAndBytesConfig] = None"},{name:"trust_remote_code",val:": bool = False"},{name:"use_chat_template",val:": bool = False"},{name:"compile",val:": bool = False"},{name:"base_model",val:": str = None"}],source:"https://github.com/huggingface/lighteval/blob/main/src/lighteval/models/model_config.py#L176"}}),T=new $({props:{name:"class lighteval.models.model_config.InferenceEndpointModelConfig",anchor:"lighteval.models.model_config.InferenceEndpointModelConfig",parameters:[{name:"name",val:": str"},{name:"repository",val:": str"},{name:"accelerator",val:": str"},{name:"vendor",val:": str"},{name:"region",val:": str"},{name:"instance_size",val:": str"},{name:"instance_type",val:": str"},{name:"model_dtype",val:": str"},{name:"framework",val:": str = 'pytorch'"},{name:"endpoint_type",val:": str = 'protected'"},{name:"should_reuse_existing",val:": bool = False"},{name:"add_special_tokens",val:": bool = True"},{name:"revision",val:": str = 'main'"},{name:"namespace",val:": str = None"},{name:"image_url",val:": str = None"},{name:"env_vars",val:": dict = None"}],source:"https://github.com/huggingface/lighteval/blob/main/src/lighteval/models/model_config.py#L258"}}),B=new $({props:{name:"nullable_keys",anchor:"lighteval.models.model_config.InferenceEndpointModelConfig.nullable_keys",parameters:[],source:"https://github.com/huggingface/lighteval/blob/main/src/lighteval/models/model_config.py#L292"}}),I=new $({props:{name:"class lighteval.models.model_config.InferenceModelConfig",anchor:"lighteval.models.model_config.InferenceModelConfig",parameters:[{name:"model",val:": str"},{name:"add_special_tokens",val:": bool = True"}],source:"https://github.com/huggingface/lighteval/blob/main/src/lighteval/models/model_config.py#L252"}}),D=new $({props:{name:"class lighteval.models.model_config.TGIModelConfig",anchor:"lighteval.models.model_config.TGIModelConfig",parameters:[{name:"inference_server_address",val:": str"},{name:"inference_server_auth",val:": str"},{name:"model_id",val:": str"}],source:"https://github.com/huggingface/lighteval/blob/main/src/lighteval/models/model_config.py#L240"}}),q=new $({props:{name:"class lighteval.models.model_config.VLLMModelConfig",anchor:"lighteval.models.model_config.VLLMModelConfig",parameters:[{name:"pretrained",val:": str"},{name:"gpu_memory_utilisation",val:": float = 0.9"},{name:"revision",val:": str = 'main'"},{name:"dtype",val:": str | None = None"},{name:"tensor_parallel_size",val:": int = 1"},{name:"pipeline_parallel_size",val:": int = 1"},{name:"data_parallel_size",val:": int = 1"},{name:"max_model_length",val:": int | None = None"},{name:"swap_space",val:": int = 4"},{name:"seed",val:": int = 1234"},{name:"trust_remote_code",val:": bool = False"},{name:"use_chat_template",val:": bool = False"},{name:"add_special_tokens",val:": bool = True"},{name:"multichoice_continuations_start_space",val:": bool = True"},{name:"pairwise_tokenization",val:": bool = False"},{name:"subfolder",val:": typing.Optional[str] = None"},{name:"temperature",val:": float = 0.6"}],source:"https://github.com/huggingface/lighteval/blob/main/src/lighteval/models/model_config.py#L211"}}),A=new $({props:{name:"lighteval.models.model_config.create_model_config",anchor:"lighteval.models.model_config.create_model_config",parameters:[{name:"use_chat_template",val:": bool"},{name:"override_batch_size",val:": int"},{name:"accelerator",val:": typing.Optional[ForwardRef('Accelerator')]"},{name:"model_args",val:": typing.Union[str, dict] = None"},{name:"model_config_path",val:": str = None"}],parametersDescription:[{anchor:"lighteval.models.model_config.create_model_config.accelerator(Union[Accelerator,",description:"<strong>accelerator(Union[Accelerator,</strong> None]) &#x2014; accelerator to use for model training.",name:"accelerator(Union[Accelerator,"},{anchor:"lighteval.models.model_config.create_model_config.use_chat_template",description:"<strong>use_chat_template</strong> (bool) &#x2014; whether to use the chat template or not. Set to True for chat or ift models",name:"use_chat_template"},{anchor:"lighteval.models.model_config.create_model_config.override_batch_size",description:"<strong>override_batch_size</strong> (int) &#x2014; frozen batch size to use",name:"override_batch_size"},{anchor:"lighteval.models.model_config.create_model_config.model_args",description:`<strong>model_args</strong> (Optional[Union[str, dict]]) &#x2014; Parameters to create the model, passed as a string (like the CLI kwargs or dict).
This option only allows to create a dummy model using <code>dummy</code> or a base model (using accelerate or no accelerator), in
which case corresponding full model args available are the arguments of the [[BaseModelConfig]].
Minimal configuration is <code>pretrained=&lt;name_of_the_model_on_the_hub&gt;</code>.`,name:"model_args"},{anchor:"lighteval.models.model_config.create_model_config.model_config_path",description:`<strong>model_config_path</strong> (Optional[str]) &#x2014; Path to the parameters to create the model, passed as a config file. This allows to create
all possible model configurations (base, adapter, peft, inference endpoints, tgi&#x2026;)`,name:"model_config_path"}],source:"https://github.com/huggingface/lighteval/blob/main/src/lighteval/models/model_config.py#L302",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>model configuration.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Union[BaseModelConfig, AdapterModelConfig, DeltaModelConfig, TGIModelConfig, InferenceEndpointModelConfig, DummyModelConfig]</p>
`,raiseDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<ul>
<li><code>ValueError</code> — If both an inference server address and model arguments are provided.</li>
</ul>
`,raiseType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>ValueError</code></p>
`}}),L=new De({props:{source:"https://github.com/huggingface/lighteval/blob/main/docs/source/package_reference/model_config.mdx"}}),{c(){b=i("meta"),K=a(),R=i("p"),Q=a(),c(C.$$.fragment),X=a(),d=i("div"),c(z.$$.fragment),me=a(),P=i("p"),P.textContent=ue,ce=a(),U=i("p"),U.innerHTML=ve,Y=a(),M=i("div"),c(w.$$.fragment),Z=a(),N=i("div"),c(k.$$.fragment),ee=a(),y=i("div"),c(T.$$.fragment),ge=a(),x=i("div"),c(B.$$.fragment),pe=a(),V=i("p"),V.textContent=be,te=a(),O=i("div"),c(I.$$.fragment),oe=a(),F=i("div"),c(D.$$.fragment),ne=a(),E=i("div"),c(q.$$.fragment),ae=a(),m=i("div"),c(A.$$.fragment),fe=a(),H=i("p"),H.textContent=ye,he=a(),W=i("p"),W.textContent=$e,le=a(),c(L.$$.fragment),ie=a(),j=i("p"),this.h()},l(e){const o=Ie("svelte-u9bgzb",document.head);b=r(o,"META",{name:!0,content:!0}),o.forEach(t),K=l(e),R=r(e,"P",{}),g(R).forEach(t),Q=l(e),p(C.$$.fragment,e),X=l(e),d=r(e,"DIV",{class:!0});var S=g(d);p(z.$$.fragment,S),me=l(S),P=r(S,"P",{"data-svelte-h":!0}),J(P)!=="svelte-rh03fc"&&(P.textContent=ue),ce=l(S),U=r(S,"P",{"data-svelte-h":!0}),J(U)!=="svelte-mdcuay"&&(U.innerHTML=ve),S.forEach(t),Y=l(e),M=r(e,"DIV",{class:!0});var xe=g(M);p(w.$$.fragment,xe),xe.forEach(t),Z=l(e),N=r(e,"DIV",{class:!0});var Ce=g(N);p(k.$$.fragment,Ce),Ce.forEach(t),ee=l(e),y=r(e,"DIV",{class:!0});var se=g(y);p(T.$$.fragment,se),ge=l(se),x=r(se,"DIV",{class:!0});var de=g(x);p(B.$$.fragment,de),pe=l(de),V=r(de,"P",{"data-svelte-h":!0}),J(V)!=="svelte-nya5bv"&&(V.textContent=be),de.forEach(t),se.forEach(t),te=l(e),O=r(e,"DIV",{class:!0});var ze=g(O);p(I.$$.fragment,ze),ze.forEach(t),oe=l(e),F=r(e,"DIV",{class:!0});var Me=g(F);p(D.$$.fragment,Me),Me.forEach(t),ne=l(e),E=r(e,"DIV",{class:!0});var we=g(E);p(q.$$.fragment,we),we.forEach(t),ae=l(e),m=r(e,"DIV",{class:!0});var G=g(m);p(A.$$.fragment,G),fe=l(G),H=r(G,"P",{"data-svelte-h":!0}),J(H)!=="svelte-19st0js"&&(H.textContent=ye),he=l(G),W=r(G,"P",{"data-svelte-h":!0}),J(W)!=="svelte-ydithz"&&(W.textContent=$e),G.forEach(t),le=l(e),p(L.$$.fragment,e),ie=l(e),j=r(e,"P",{}),g(j).forEach(t),this.h()},h(){f(b,"name","hf:doc:metadata"),f(b,"content",qe),f(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(m,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,o){s(document.head,b),n(e,K,o),n(e,R,o),n(e,Q,o),h(C,e,o),n(e,X,o),n(e,d,o),h(z,d,null),s(d,me),s(d,P),s(d,ce),s(d,U),n(e,Y,o),n(e,M,o),h(w,M,null),n(e,Z,o),n(e,N,o),h(k,N,null),n(e,ee,o),n(e,y,o),h(T,y,null),s(y,ge),s(y,x),h(B,x,null),s(x,pe),s(x,V),n(e,te,o),n(e,O,o),h(I,O,null),n(e,oe,o),n(e,F,o),h(D,F,null),n(e,ne,o),n(e,E,o),h(q,E,null),n(e,ae,o),n(e,m,o),h(A,m,null),s(m,fe),s(m,H),s(m,he),s(m,W),n(e,le,o),h(L,e,o),n(e,ie,o),n(e,j,o),re=!0},p:ke,i(e){re||(_(C.$$.fragment,e),_(z.$$.fragment,e),_(w.$$.fragment,e),_(k.$$.fragment,e),_(T.$$.fragment,e),_(B.$$.fragment,e),_(I.$$.fragment,e),_(D.$$.fragment,e),_(q.$$.fragment,e),_(A.$$.fragment,e),_(L.$$.fragment,e),re=!0)},o(e){u(C.$$.fragment,e),u(z.$$.fragment,e),u(w.$$.fragment,e),u(k.$$.fragment,e),u(T.$$.fragment,e),u(B.$$.fragment,e),u(I.$$.fragment,e),u(D.$$.fragment,e),u(q.$$.fragment,e),u(A.$$.fragment,e),u(L.$$.fragment,e),re=!1},d(e){e&&(t(K),t(R),t(Q),t(X),t(d),t(Y),t(M),t(Z),t(N),t(ee),t(y),t(te),t(O),t(oe),t(F),t(ne),t(E),t(ae),t(m),t(le),t(ie),t(j)),t(b),v(C,e),v(z),v(w),v(k),v(T),v(B),v(I),v(D),v(q),v(A),v(L,e)}}}const qe='{"title":"ModelConfig","local":"lighteval.models.model_config.BaseModelConfig","sections":[],"depth":1}';function Ae(_e){return Te(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class He extends Be{constructor(b){super(),Oe(this,b,Ae,Ee,Ne,{})}}export{He as component};
